<?
/*    -------------HMAuth------------------
**
**   Html Form authentication by HMAC Authentication.
**   See README.* for a description.
**  
**  Copyright 2005 Stefano Di Paola (stefano.dipaola@wisec.it)
**  Released under GPL 2.0
*/
session_start();


 function hmacsha1($key, $data) {
   $blocksize=64;
   $hashfunc='sha1';
   if (strlen($key)>$blocksize)
       $key=pack('H*', sha1($key));
   $key=str_pad($key,$blocksize,chr(0x00));
   $ipad=str_repeat(chr(0x36),$blocksize);
   $opad=str_repeat(chr(0x5c),$blocksize);
   $hmac = pack(
	       'H*',sha1(
		   ($key^$opad).pack(
		       'H*',sha1(
			   ($key^$ipad).$data
		       )
		   )
	       )
	   );
   return bin2hex($hmac);
 }
 
 
 
function test_hmauth($clientresp, $passw, $message){

    if(isset($clientresp))
    {
      $sha=  hmacsha1($passw,$message) ;
      // echo $sha."<br>";
      //echo $clientresp."<br>";
      //echo $_SESSION['message']."<br>";

      if(!strcmp($sha,$clientresp ))
      return true; 
    }

    return false;
}



function print_hmauth_input($name, $passwfieldname="pwd") {

    $formsnip= '
    <script src="/scripts/sha1.js" ></script>';
    $formsnip.= "
    <script>
    function go(e)
    {
      this.auth.value = hex_hmac_sha1(document.$name.$passwfieldname.value, this.message.value);
      this.$passwfieldname.value='';
      this.message.value='';
      this.submit();
      return true;
    }
      document.$name.onsubmit = go ;
    </script>\n";

    $formsnip.=  '<input type="hidden" name="message" value="';

    for($i=0;$i<30;$i++)
       $s.= sprintf( "%c",mt_rand(0, 255));
    
    $_SESSION['message']=base64_encode($s);
    $formsnip.=  $_SESSION['message'];
    $formsnip.= '" >
    <input type="password" name="'.$passwfieldname.'" >
    <input type="hidden" name="auth" >

    ';
    return $formsnip;
}
?>
