<?
/*
   Autenticazione HMAC:
   HMAC: Keyed-Hashing for Message Authentication
   http://www.fehcom.de/rfc/rfc2104.txt
   
   Per autenticare un utente senza che ci sia l'invio
   di una password.
   Il server manda una stringa casuale.
   
   Il client inserendo la password cifra con una funzione
   javascript il messaggio e lo reinvia al server.
   
   il server controlla se il messaggio criptato con la stessa password 
   e' uguale se si allora l'utente e' autenticato.
   
   Questo sistema permette di non inviare segreti su linee non sicure.
   
   Stefano Di Paola.
*/
session_start();

$password="123";

  function hmacsha1($key,$data) {
    $blocksize=64;
    $hashfunc='sha1';
    if (strlen($key)>$blocksize)
	$key=pack('H*', $hashfunc($key));
    $key=str_pad($key,$blocksize,chr(0x00));
    $ipad=str_repeat(chr(0x36),$blocksize);
    $opad=str_repeat(chr(0x5c),$blocksize);
    $hmac = pack(
        	'H*',$hashfunc(
                    ($key^$opad).pack(
                	'H*',$hashfunc(
                            ($key^$ipad).$data
                	)
                    )
        	)
            );
    return bin2hex($hmac);
  }

 if(isset($_GET['auth']))
 {
   $sha=   hmacsha1($password,$_SESSION['message']) ;
   echo $sha."<br>";
   echo  $_GET['auth']."<br>";
   
   if(!strcmp($sha,$_GET['auth']))
   echo "OK";
   else
   echo "ko";
   return; 
 }
?>
<html>
<body>
<script src="sha1.js" />
<h2>Autenticazione</h2>
<form name="c" action="<?=$_SERVER['SELF']?>">

<input type="hidden" name="message" value="<?
for($i=0;$i<90;$i++)
{ 
 $s.= sprintf( "%c",mt_rand(0, 255));
}
$_SESSION['message']=base64_encode($s);
echo $_SESSION['message'];
?>" >
Inserisci la tua password <input type="password" name="pwd" >
<input type="hidden" name="auth" >

<input type=submit value="ok" OnClick="javascript:go()">
</form>
</body>
</html>
